Imported Upstream version 2.15.4
[platform/upstream/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10    or: $dashless [--quiet] init [--] [<path>...]
11    or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14    or: $dashless [--quiet] foreach [--recursive] <command>
15    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16    or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
24
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
29
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 require_init=
38 files=
39 remote=
40 nofetch=
41 update=
42 prefix=
43 custom_name=
44 depth=
45 progress=
46
47 die_if_unmatched ()
48 {
49         if test "$1" = "#unmatched"
50         then
51                 exit ${2:-1}
52         fi
53 }
54
55 #
56 # Print a submodule configuration setting
57 #
58 # $1 = submodule name
59 # $2 = option name
60 # $3 = default value
61 #
62 # Checks in the usual git-config places first (for overrides),
63 # otherwise it falls back on .gitmodules.  This allows you to
64 # distribute project-wide defaults in .gitmodules, while still
65 # customizing individual repositories if necessary.  If the option is
66 # not in .gitmodules either, print a default value.
67 #
68 get_submodule_config () {
69         name="$1"
70         option="$2"
71         default="$3"
72         value=$(git config submodule."$name"."$option")
73         if test -z "$value"
74         then
75                 value=$(git config -f .gitmodules submodule."$name"."$option")
76         fi
77         printf '%s' "${value:-$default}"
78 }
79
80 isnumber()
81 {
82         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83 }
84
85 # Sanitize the local git environment for use within a submodule. We
86 # can't simply use clear_local_git_env since we want to preserve some
87 # of the settings from GIT_CONFIG_PARAMETERS.
88 sanitize_submodule_env()
89 {
90         save_config=$GIT_CONFIG_PARAMETERS
91         clear_local_git_env
92         GIT_CONFIG_PARAMETERS=$save_config
93         export GIT_CONFIG_PARAMETERS
94 }
95
96 #
97 # Add a new submodule to the working tree, .gitmodules and the index
98 #
99 # $@ = repo path
100 #
101 # optional branch is stored in global branch variable
102 #
103 cmd_add()
104 {
105         # parse $args after "submodule ... add".
106         reference_path=
107         while test $# -ne 0
108         do
109                 case "$1" in
110                 -b | --branch)
111                         case "$2" in '') usage ;; esac
112                         branch=$2
113                         shift
114                         ;;
115                 -f | --force)
116                         force=$1
117                         ;;
118                 -q|--quiet)
119                         GIT_QUIET=1
120                         ;;
121                 --reference)
122                         case "$2" in '') usage ;; esac
123                         reference_path=$2
124                         shift
125                         ;;
126                 --reference=*)
127                         reference_path="${1#--reference=}"
128                         ;;
129                 --name)
130                         case "$2" in '') usage ;; esac
131                         custom_name=$2
132                         shift
133                         ;;
134                 --depth)
135                         case "$2" in '') usage ;; esac
136                         depth="--depth=$2"
137                         shift
138                         ;;
139                 --depth=*)
140                         depth=$1
141                         ;;
142                 --)
143                         shift
144                         break
145                         ;;
146                 -*)
147                         usage
148                         ;;
149                 *)
150                         break
151                         ;;
152                 esac
153                 shift
154         done
155
156         if test -n "$reference_path"
157         then
158                 is_absolute_path "$reference_path" ||
159                 reference_path="$wt_prefix$reference_path"
160
161                 reference="--reference=$reference_path"
162         fi
163
164         repo=$1
165         sm_path=$2
166
167         if test -z "$sm_path"; then
168                 sm_path=$(printf '%s\n' "$repo" |
169                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170         fi
171
172         if test -z "$repo" || test -z "$sm_path"; then
173                 usage
174         fi
175
176         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177
178         # assure repo is absolute or relative to parent
179         case "$repo" in
180         ./*|../*)
181                 test -z "$wt_prefix" ||
182                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183
184                 # dereference source url relative to parent's url
185                 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
186                 ;;
187         *:*|/*)
188                 # absolute url
189                 realrepo=$repo
190                 ;;
191         *)
192                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
193         ;;
194         esac
195
196         # normalize path:
197         # multiple //; leading ./; /./; /../; trailing /
198         sm_path=$(printf '%s/\n' "$sm_path" |
199                 sed -e '
200                         s|//*|/|g
201                         s|^\(\./\)*||
202                         s|/\(\./\)*|/|g
203                         :start
204                         s|\([^/]*\)/\.\./||
205                         tstart
206                         s|/*$||
207                 ')
208         if test -z "$force"
209         then
210                 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211                 die "$(eval_gettext "'\$sm_path' already exists in the index")"
212         else
213                 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
214                 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
215         fi
216
217         if test -z "$force" &&
218                 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
219         then
220                 eval_gettextln "The following path is ignored by one of your .gitignore files:
221 \$sm_path
222 Use -f if you really want to add it." >&2
223                 exit 1
224         fi
225
226         if test -n "$custom_name"
227         then
228                 sm_name="$custom_name"
229         else
230                 sm_name="$sm_path"
231         fi
232
233         if ! git submodule--helper check-name "$sm_name"
234         then
235                 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
236         fi
237
238         # perhaps the path exists and is already a git repo, else clone it
239         if test -e "$sm_path"
240         then
241                 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
242                 then
243                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
244                 else
245                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
246                 fi
247
248         else
249                 if test -d ".git/modules/$sm_name"
250                 then
251                         if test -z "$force"
252                         then
253                                 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
254                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
255                                 die "$(eval_gettextln "\
256 If you want to reuse this local git directory instead of cloning again from
257   \$realrepo
258 use the '--force' option. If the local git directory is not the correct repo
259 or you are unsure what this means choose another name with the '--name' option.")"
260                         else
261                                 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
262                         fi
263                 fi
264                 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
265                 (
266                         sanitize_submodule_env
267                         cd "$sm_path" &&
268                         # ash fails to wordsplit ${branch:+-b "$branch"...}
269                         case "$branch" in
270                         '') git checkout -f -q ;;
271                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
272                         esac
273                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
274         fi
275         git config submodule."$sm_name".url "$realrepo"
276
277         git add --no-warn-embedded-repo $force "$sm_path" ||
278         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
279
280         git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
281         git config -f .gitmodules submodule."$sm_name".url "$repo" &&
282         if test -n "$branch"
283         then
284                 git config -f .gitmodules submodule."$sm_name".branch "$branch"
285         fi &&
286         git add --force .gitmodules ||
287         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
288
289         # NEEDSWORK: In a multi-working-tree world, this needs to be
290         # set in the per-worktree config.
291         if git config --get submodule.active >/dev/null
292         then
293                 # If the submodule being adding isn't already covered by the
294                 # current configured pathspec, set the submodule's active flag
295                 if ! git submodule--helper is-active "$sm_path"
296                 then
297                         git config submodule."$sm_name".active "true"
298                 fi
299         else
300                 git config submodule."$sm_name".active "true"
301         fi
302 }
303
304 #
305 # Execute an arbitrary command sequence in each checked out
306 # submodule
307 #
308 # $@ = command to execute
309 #
310 cmd_foreach()
311 {
312         # parse $args after "submodule ... foreach".
313         while test $# -ne 0
314         do
315                 case "$1" in
316                 -q|--quiet)
317                         GIT_QUIET=1
318                         ;;
319                 --recursive)
320                         recursive=1
321                         ;;
322                 -*)
323                         usage
324                         ;;
325                 *)
326                         break
327                         ;;
328                 esac
329                 shift
330         done
331
332         toplevel=$(pwd)
333
334         # dup stdin so that it can be restored when running the external
335         # command in the subshell (and a recursive call to this function)
336         exec 3<&0
337
338         {
339                 git submodule--helper list --prefix "$wt_prefix" ||
340                 echo "#unmatched" $?
341         } |
342         while read -r mode sha1 stage sm_path
343         do
344                 die_if_unmatched "$mode" "$sha1"
345                 if test -e "$sm_path"/.git
346                 then
347                         displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
348                         say "$(eval_gettext "Entering '\$displaypath'")"
349                         name=$(git submodule--helper name "$sm_path")
350                         (
351                                 prefix="$prefix$sm_path/"
352                                 sanitize_submodule_env
353                                 cd "$sm_path" &&
354                                 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
355                                 # we make $path available to scripts ...
356                                 path=$sm_path &&
357                                 if test $# -eq 1
358                                 then
359                                         eval "$1"
360                                 else
361                                         "$@"
362                                 fi &&
363                                 if test -n "$recursive"
364                                 then
365                                         cmd_foreach "--recursive" "$@"
366                                 fi
367                         ) <&3 3<&- ||
368                         die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
369                 fi
370         done
371 }
372
373 #
374 # Register submodules in .git/config
375 #
376 # $@ = requested paths (default to all)
377 #
378 cmd_init()
379 {
380         # parse $args after "submodule ... init".
381         while test $# -ne 0
382         do
383                 case "$1" in
384                 -q|--quiet)
385                         GIT_QUIET=1
386                         ;;
387                 --)
388                         shift
389                         break
390                         ;;
391                 -*)
392                         usage
393                         ;;
394                 *)
395                         break
396                         ;;
397                 esac
398                 shift
399         done
400
401         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet}  "$@"
402 }
403
404 #
405 # Unregister submodules from .git/config and remove their work tree
406 #
407 cmd_deinit()
408 {
409         # parse $args after "submodule ... deinit".
410         deinit_all=
411         while test $# -ne 0
412         do
413                 case "$1" in
414                 -f|--force)
415                         force=$1
416                         ;;
417                 -q|--quiet)
418                         GIT_QUIET=1
419                         ;;
420                 --all)
421                         deinit_all=t
422                         ;;
423                 --)
424                         shift
425                         break
426                         ;;
427                 -*)
428                         usage
429                         ;;
430                 *)
431                         break
432                         ;;
433                 esac
434                 shift
435         done
436
437         if test -n "$deinit_all" && test "$#" -ne 0
438         then
439                 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
440                 usage
441         fi
442         if test $# = 0 && test -z "$deinit_all"
443         then
444                 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
445         fi
446
447         {
448                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
449                 echo "#unmatched" $?
450         } |
451         while read -r mode sha1 stage sm_path
452         do
453                 die_if_unmatched "$mode" "$sha1"
454                 name=$(git submodule--helper name "$sm_path") || exit
455
456                 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
457
458                 # Remove the submodule work tree (unless the user already did it)
459                 if test -d "$sm_path"
460                 then
461                         # Protect submodules containing a .git directory
462                         if test -d "$sm_path/.git"
463                         then
464                                 die "$(eval_gettext "\
465 Submodule work tree '\$displaypath' contains a .git directory
466 (use 'rm -rf' if you really want to remove it including all of its history)")"
467                         fi
468
469                         if test -z "$force"
470                         then
471                                 git rm -qn "$sm_path" ||
472                                 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
473                         fi
474                         rm -rf "$sm_path" &&
475                         say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
476                         say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
477                 fi
478
479                 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
480
481                 # Remove the .git/config entries (unless the user already did it)
482                 if test -n "$(git config --get-regexp submodule."$name\.")"
483                 then
484                         # Remove the whole section so we have a clean state when
485                         # the user later decides to init this submodule again
486                         url=$(git config submodule."$name".url)
487                         git config --remove-section submodule."$name" 2>/dev/null &&
488                         say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
489                 fi
490         done
491 }
492
493 is_tip_reachable () (
494         sanitize_submodule_env &&
495         cd "$1" &&
496         rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
497         test -z "$rev"
498 )
499
500 fetch_in_submodule () (
501         sanitize_submodule_env &&
502         cd "$1" &&
503         case "$2" in
504         '')
505                 git fetch ;;
506         *)
507                 shift
508                 git fetch $(get_default_remote) "$@" ;;
509         esac
510 )
511
512 #
513 # Update each submodule path to correct revision, using clone and checkout as needed
514 #
515 # $@ = requested paths (default to all)
516 #
517 cmd_update()
518 {
519         # parse $args after "submodule ... update".
520         while test $# -ne 0
521         do
522                 case "$1" in
523                 -q|--quiet)
524                         GIT_QUIET=1
525                         ;;
526                 --progress)
527                         progress="--progress"
528                         ;;
529                 -i|--init)
530                         init=1
531                         ;;
532                 --require-init)
533                         init=1
534                         require_init=1
535                         ;;
536                 --remote)
537                         remote=1
538                         ;;
539                 -N|--no-fetch)
540                         nofetch=1
541                         ;;
542                 -f|--force)
543                         force=$1
544                         ;;
545                 -r|--rebase)
546                         update="rebase"
547                         ;;
548                 --reference)
549                         case "$2" in '') usage ;; esac
550                         reference="--reference=$2"
551                         shift
552                         ;;
553                 --reference=*)
554                         reference="$1"
555                         ;;
556                 -m|--merge)
557                         update="merge"
558                         ;;
559                 --recursive)
560                         recursive=1
561                         ;;
562                 --checkout)
563                         update="checkout"
564                         ;;
565                 --recommend-shallow)
566                         recommend_shallow="--recommend-shallow"
567                         ;;
568                 --no-recommend-shallow)
569                         recommend_shallow="--no-recommend-shallow"
570                         ;;
571                 --depth)
572                         case "$2" in '') usage ;; esac
573                         depth="--depth=$2"
574                         shift
575                         ;;
576                 --depth=*)
577                         depth=$1
578                         ;;
579                 -j|--jobs)
580                         case "$2" in '') usage ;; esac
581                         jobs="--jobs=$2"
582                         shift
583                         ;;
584                 --jobs=*)
585                         jobs=$1
586                         ;;
587                 --)
588                         shift
589                         break
590                         ;;
591                 -*)
592                         usage
593                         ;;
594                 *)
595                         break
596                         ;;
597                 esac
598                 shift
599         done
600
601         if test -n "$init"
602         then
603                 cmd_init "--" "$@" || return
604         fi
605
606         {
607         git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
608                 ${progress:+"$progress"} \
609                 ${wt_prefix:+--prefix "$wt_prefix"} \
610                 ${prefix:+--recursive-prefix "$prefix"} \
611                 ${update:+--update "$update"} \
612                 ${reference:+"$reference"} \
613                 ${depth:+--depth "$depth"} \
614                 ${require_init:+--require-init} \
615                 ${recommend_shallow:+"$recommend_shallow"} \
616                 ${jobs:+$jobs} \
617                 "$@" || echo "#unmatched" $?
618         } | {
619         err=
620         while read -r mode sha1 stage just_cloned sm_path
621         do
622                 die_if_unmatched "$mode" "$sha1"
623
624                 name=$(git submodule--helper name "$sm_path") || exit
625                 if ! test -z "$update"
626                 then
627                         update_module=$update
628                 else
629                         update_module=$(git config submodule."$name".update)
630                         if test -z "$update_module"
631                         then
632                                 update_module="checkout"
633                         fi
634                 fi
635
636                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
637
638                 if test $just_cloned -eq 1
639                 then
640                         subsha1=
641                         case "$update_module" in
642                         merge | rebase | none)
643                                 update_module=checkout ;;
644                         esac
645                 else
646                         subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
647                                 git rev-parse --verify HEAD) ||
648                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
649                 fi
650
651                 if test -n "$remote"
652                 then
653                         branch=$(git submodule--helper remote-branch "$sm_path")
654                         if test -z "$nofetch"
655                         then
656                                 # Fetch remote before determining tracking $sha1
657                                 fetch_in_submodule "$sm_path" $depth ||
658                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
659                         fi
660                         remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
661                         sha1=$(sanitize_submodule_env; cd "$sm_path" &&
662                                 git rev-parse --verify "${remote_name}/${branch}") ||
663                         die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
664                 fi
665
666                 if test "$subsha1" != "$sha1" || test -n "$force"
667                 then
668                         subforce=$force
669                         # If we don't already have a -f flag and the submodule has never been checked out
670                         if test -z "$subsha1" && test -z "$force"
671                         then
672                                 subforce="-f"
673                         fi
674
675                         if test -z "$nofetch"
676                         then
677                                 # Run fetch only if $sha1 isn't present or it
678                                 # is not reachable from a ref.
679                                 is_tip_reachable "$sm_path" "$sha1" ||
680                                 fetch_in_submodule "$sm_path" $depth ||
681                                 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
682
683                                 # Now we tried the usual fetch, but $sha1 may
684                                 # not be reachable from any of the refs
685                                 is_tip_reachable "$sm_path" "$sha1" ||
686                                 fetch_in_submodule "$sm_path" $depth "$sha1" ||
687                                 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
688                         fi
689
690                         must_die_on_failure=
691                         case "$update_module" in
692                         checkout)
693                                 command="git checkout $subforce -q"
694                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
695                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
696                                 ;;
697                         rebase)
698                                 command="git rebase"
699                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
700                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
701                                 must_die_on_failure=yes
702                                 ;;
703                         merge)
704                                 command="git merge"
705                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
706                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
707                                 must_die_on_failure=yes
708                                 ;;
709                         !*)
710                                 command="${update_module#!}"
711                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
712                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
713                                 must_die_on_failure=yes
714                                 ;;
715                         *)
716                                 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
717                         esac
718
719                         if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
720                         then
721                                 say "$say_msg"
722                         elif test -n "$must_die_on_failure"
723                         then
724                                 die_with_status 2 "$die_msg"
725                         else
726                                 err="${err};$die_msg"
727                                 continue
728                         fi
729                 fi
730
731                 if test -n "$recursive"
732                 then
733                         (
734                                 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
735                                 wt_prefix=
736                                 sanitize_submodule_env
737                                 cd "$sm_path" &&
738                                 eval cmd_update
739                         )
740                         res=$?
741                         if test $res -gt 0
742                         then
743                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
744                                 if test $res -ne 2
745                                 then
746                                         err="${err};$die_msg"
747                                         continue
748                                 else
749                                         die_with_status $res "$die_msg"
750                                 fi
751                         fi
752                 fi
753         done
754
755         if test -n "$err"
756         then
757                 OIFS=$IFS
758                 IFS=';'
759                 for e in $err
760                 do
761                         if test -n "$e"
762                         then
763                                 echo >&2 "$e"
764                         fi
765                 done
766                 IFS=$OIFS
767                 exit 1
768         fi
769         }
770 }
771
772 set_name_rev () {
773         revname=$( (
774                 sanitize_submodule_env
775                 cd "$1" && {
776                         git describe "$2" 2>/dev/null ||
777                         git describe --tags "$2" 2>/dev/null ||
778                         git describe --contains "$2" 2>/dev/null ||
779                         git describe --all --always "$2"
780                 }
781         ) )
782         test -z "$revname" || revname=" ($revname)"
783 }
784 #
785 # Show commit summary for submodules in index or working tree
786 #
787 # If '--cached' is given, show summary between index and given commit,
788 # or between working tree and given commit
789 #
790 # $@ = [commit (default 'HEAD'),] requested paths (default all)
791 #
792 cmd_summary() {
793         summary_limit=-1
794         for_status=
795         diff_cmd=diff-index
796
797         # parse $args after "submodule ... summary".
798         while test $# -ne 0
799         do
800                 case "$1" in
801                 --cached)
802                         cached="$1"
803                         ;;
804                 --files)
805                         files="$1"
806                         ;;
807                 --for-status)
808                         for_status="$1"
809                         ;;
810                 -n|--summary-limit)
811                         summary_limit="$2"
812                         isnumber "$summary_limit" || usage
813                         shift
814                         ;;
815                 --summary-limit=*)
816                         summary_limit="${1#--summary-limit=}"
817                         isnumber "$summary_limit" || usage
818                         ;;
819                 --)
820                         shift
821                         break
822                         ;;
823                 -*)
824                         usage
825                         ;;
826                 *)
827                         break
828                         ;;
829                 esac
830                 shift
831         done
832
833         test $summary_limit = 0 && return
834
835         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
836         then
837                 head=$rev
838                 test $# = 0 || shift
839         elif test -z "$1" || test "$1" = "HEAD"
840         then
841                 # before the first commit: compare with an empty tree
842                 head=$(git hash-object -w -t tree --stdin </dev/null)
843                 test -z "$1" || shift
844         else
845                 head="HEAD"
846         fi
847
848         if [ -n "$files" ]
849         then
850                 test -n "$cached" &&
851                 die "$(gettext "The --cached option cannot be used with the --files option")"
852                 diff_cmd=diff-files
853                 head=
854         fi
855
856         cd_to_toplevel
857         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
858         # Get modified modules cared by user
859         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
860                 sane_egrep '^:([0-7]* )?160000' |
861                 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
862                 do
863                         # Always show modules deleted or type-changed (blob<->module)
864                         if test "$status" = D || test "$status" = T
865                         then
866                                 printf '%s\n' "$sm_path"
867                                 continue
868                         fi
869                         # Respect the ignore setting for --for-status.
870                         if test -n "$for_status"
871                         then
872                                 name=$(git submodule--helper name "$sm_path")
873                                 ignore_config=$(get_submodule_config "$name" ignore none)
874                                 test $status != A && test $ignore_config = all && continue
875                         fi
876                         # Also show added or modified modules which are checked out
877                         GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
878                         printf '%s\n' "$sm_path"
879                 done
880         )
881
882         test -z "$modules" && return
883
884         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
885         sane_egrep '^:([0-7]* )?160000' |
886         cut -c2- |
887         while read -r mod_src mod_dst sha1_src sha1_dst status name
888         do
889                 if test -z "$cached" &&
890                         test $sha1_dst = 0000000000000000000000000000000000000000
891                 then
892                         case "$mod_dst" in
893                         160000)
894                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
895                                 ;;
896                         100644 | 100755 | 120000)
897                                 sha1_dst=$(git hash-object $name)
898                                 ;;
899                         000000)
900                                 ;; # removed
901                         *)
902                                 # unexpected type
903                                 eval_gettextln "unexpected mode \$mod_dst" >&2
904                                 continue ;;
905                         esac
906                 fi
907                 missing_src=
908                 missing_dst=
909
910                 test $mod_src = 160000 &&
911                 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
912                 missing_src=t
913
914                 test $mod_dst = 160000 &&
915                 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
916                 missing_dst=t
917
918                 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
919
920                 total_commits=
921                 case "$missing_src,$missing_dst" in
922                 t,)
923                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
924                         ;;
925                 ,t)
926                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
927                         ;;
928                 t,t)
929                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
930                         ;;
931                 *)
932                         errmsg=
933                         total_commits=$(
934                         if test $mod_src = 160000 && test $mod_dst = 160000
935                         then
936                                 range="$sha1_src...$sha1_dst"
937                         elif test $mod_src = 160000
938                         then
939                                 range=$sha1_src
940                         else
941                                 range=$sha1_dst
942                         fi
943                         GIT_DIR="$name/.git" \
944                         git rev-list --first-parent $range -- | wc -l
945                         )
946                         total_commits=" ($(($total_commits + 0)))"
947                         ;;
948                 esac
949
950                 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
951                 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
952                 if test $status = T
953                 then
954                         blob="$(gettext "blob")"
955                         submodule="$(gettext "submodule")"
956                         if test $mod_dst = 160000
957                         then
958                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
959                         else
960                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
961                         fi
962                 else
963                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
964                 fi
965                 if test -n "$errmsg"
966                 then
967                         # Don't give error msg for modification whose dst is not submodule
968                         # i.e. deleted or changed to blob
969                         test $mod_dst = 160000 && echo "$errmsg"
970                 else
971                         if test $mod_src = 160000 && test $mod_dst = 160000
972                         then
973                                 limit=
974                                 test $summary_limit -gt 0 && limit="-$summary_limit"
975                                 GIT_DIR="$name/.git" \
976                                 git log $limit --pretty='format:  %m %s' \
977                                 --first-parent $sha1_src...$sha1_dst
978                         elif test $mod_dst = 160000
979                         then
980                                 GIT_DIR="$name/.git" \
981                                 git log --pretty='format:  > %s' -1 $sha1_dst
982                         else
983                                 GIT_DIR="$name/.git" \
984                                 git log --pretty='format:  < %s' -1 $sha1_src
985                         fi
986                         echo
987                 fi
988                 echo
989         done
990 }
991 #
992 # List all submodules, prefixed with:
993 #  - submodule not initialized
994 #  + different revision checked out
995 #
996 # If --cached was specified the revision in the index will be printed
997 # instead of the currently checked out revision.
998 #
999 # $@ = requested paths (default to all)
1000 #
1001 cmd_status()
1002 {
1003         # parse $args after "submodule ... status".
1004         while test $# -ne 0
1005         do
1006                 case "$1" in
1007                 -q|--quiet)
1008                         GIT_QUIET=1
1009                         ;;
1010                 --cached)
1011                         cached=1
1012                         ;;
1013                 --recursive)
1014                         recursive=1
1015                         ;;
1016                 --)
1017                         shift
1018                         break
1019                         ;;
1020                 -*)
1021                         usage
1022                         ;;
1023                 *)
1024                         break
1025                         ;;
1026                 esac
1027                 shift
1028         done
1029
1030         {
1031                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1032                 echo "#unmatched" $?
1033         } |
1034         while read -r mode sha1 stage sm_path
1035         do
1036                 die_if_unmatched "$mode" "$sha1"
1037                 name=$(git submodule--helper name "$sm_path") || exit
1038                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1039                 if test "$stage" = U
1040                 then
1041                         say "U$sha1 $displaypath"
1042                         continue
1043                 fi
1044                 if ! git submodule--helper is-active "$sm_path" ||
1045                 {
1046                         ! test -d "$sm_path"/.git &&
1047                         ! test -f "$sm_path"/.git
1048                 }
1049                 then
1050                         say "-$sha1 $displaypath"
1051                         continue;
1052                 fi
1053                 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1054                 then
1055                         set_name_rev "$sm_path" "$sha1"
1056                         say " $sha1 $displaypath$revname"
1057                 else
1058                         if test -z "$cached"
1059                         then
1060                                 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1061                         fi
1062                         set_name_rev "$sm_path" "$sha1"
1063                         say "+$sha1 $displaypath$revname"
1064                 fi
1065
1066                 if test -n "$recursive"
1067                 then
1068                         (
1069                                 prefix="$displaypath/"
1070                                 sanitize_submodule_env
1071                                 wt_prefix=
1072                                 cd "$sm_path" &&
1073                                 eval cmd_status
1074                         ) ||
1075                         die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1076                 fi
1077         done
1078 }
1079 #
1080 # Sync remote urls for submodules
1081 # This makes the value for remote.$remote.url match the value
1082 # specified in .gitmodules.
1083 #
1084 cmd_sync()
1085 {
1086         while test $# -ne 0
1087         do
1088                 case "$1" in
1089                 -q|--quiet)
1090                         GIT_QUIET=1
1091                         shift
1092                         ;;
1093                 --recursive)
1094                         recursive=1
1095                         shift
1096                         ;;
1097                 --)
1098                         shift
1099                         break
1100                         ;;
1101                 -*)
1102                         usage
1103                         ;;
1104                 *)
1105                         break
1106                         ;;
1107                 esac
1108         done
1109         cd_to_toplevel
1110         {
1111                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1112                 echo "#unmatched" $?
1113         } |
1114         while read -r mode sha1 stage sm_path
1115         do
1116                 die_if_unmatched "$mode" "$sha1"
1117
1118                 # skip inactive submodules
1119                 if ! git submodule--helper is-active "$sm_path"
1120                 then
1121                         continue
1122                 fi
1123
1124                 name=$(git submodule--helper name "$sm_path")
1125                 url=$(git config -f .gitmodules --get submodule."$name".url)
1126
1127                 # Possibly a url relative to parent
1128                 case "$url" in
1129                 ./*|../*)
1130                         # rewrite foo/bar as ../.. to find path from
1131                         # submodule work tree to superproject work tree
1132                         up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1133                         # guarantee a trailing /
1134                         up_path=${up_path%/}/ &&
1135                         # path from submodule work tree to submodule origin repo
1136                         sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1137                         # path from superproject work tree to submodule origin repo
1138                         super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1139                         ;;
1140                 *)
1141                         sub_origin_url="$url"
1142                         super_config_url="$url"
1143                         ;;
1144                 esac
1145
1146                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1147                 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1148                 git config submodule."$name".url "$super_config_url"
1149
1150                 if test -e "$sm_path"/.git
1151                 then
1152                 (
1153                         sanitize_submodule_env
1154                         cd "$sm_path"
1155                         remote=$(get_default_remote)
1156                         git config remote."$remote".url "$sub_origin_url"
1157
1158                         if test -n "$recursive"
1159                         then
1160                                 prefix="$prefix$sm_path/"
1161                                 eval cmd_sync
1162                         fi
1163                 )
1164                 fi
1165         done
1166 }
1167
1168 cmd_absorbgitdirs()
1169 {
1170         git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1171 }
1172
1173 # This loop parses the command line arguments to find the
1174 # subcommand name to dispatch.  Parsing of the subcommand specific
1175 # options are primarily done by the subcommand implementations.
1176 # Subcommand specific options such as --branch and --cached are
1177 # parsed here as well, for backward compatibility.
1178
1179 while test $# != 0 && test -z "$command"
1180 do
1181         case "$1" in
1182         add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1183                 command=$1
1184                 ;;
1185         -q|--quiet)
1186                 GIT_QUIET=1
1187                 ;;
1188         -b|--branch)
1189                 case "$2" in
1190                 '')
1191                         usage
1192                         ;;
1193                 esac
1194                 branch="$2"; shift
1195                 ;;
1196         --cached)
1197                 cached="$1"
1198                 ;;
1199         --)
1200                 break
1201                 ;;
1202         -*)
1203                 usage
1204                 ;;
1205         *)
1206                 break
1207                 ;;
1208         esac
1209         shift
1210 done
1211
1212 # No command word defaults to "status"
1213 if test -z "$command"
1214 then
1215     if test $# = 0
1216     then
1217         command=status
1218     else
1219         usage
1220     fi
1221 fi
1222
1223 # "-b branch" is accepted only by "add"
1224 if test -n "$branch" && test "$command" != add
1225 then
1226         usage
1227 fi
1228
1229 # "--cached" is accepted only by "status" and "summary"
1230 if test -n "$cached" && test "$command" != status && test "$command" != summary
1231 then
1232         usage
1233 fi
1234
1235 "cmd_$command" "$@"